WITH TEXT_IO; USE TEXT_IO;

PROCEDURE CALCULA IS

PACKAGE ES_FLOAT IS NEW FLOAT_IO(FLOAT); 
USE ES_FLOAT;

KEY : CHARACTER := '?';
NUM : FLOAT;
DIVIDE_BY_ZERO : EXCEPTION;

TASK CALCULATE IS
     ENTRY ADD(X : IN FLOAT);
     ENTRY SUB(X : IN FLOAT);
     ENTRY MUL(X : IN FLOAT);
     ENTRY DIV(X : IN FLOAT);
     ENTRY EQU(X : OUT FLOAT);
     ENTRY CLEAR;
END CALCULATE;

TASK BODY CALCULATE IS
     TOTAL : FLOAT := 0.0;
BEGIN
     LOOP
         SELECT
               ACCEPT ADD(X : IN FLOAT) DO
                      TOTAL := TOTAL + X;
               END ADD;
         OR
               ACCEPT SUB(X : IN FLOAT) DO
                      TOTAL := TOTAL - X;
               END SUB;
         OR
               ACCEPT MUL(X : IN FLOAT) DO
                      TOTAL := TOTAL * X;
               END MUL;
         OR
               ACCEPT DIV(X : IN FLOAT) DO
                      TOTAL := TOTAL / X;
               END DIV;
         OR
               ACCEPT EQU(X : OUT FLOAT) DO
                      X := TOTAL;
               END EQU;
         OR
               ACCEPT CLEAR DO
                      TOTAL := 0.0;
               END CLEAR;
         OR
               TERMINATE;
         END SELECT;
     END LOOP;
END CALCULATE;

PROCEDURE EXPLAIN IS
BEGIN
     NEW_LINE;
     PUT(" Esta es una simple calculadora de escritorio. Puede sumar (+).");
     NEW_LINE;
     PUT(" restar(-), multiplicar (*) y dividir (/). Teclear la");
     NEW_LINE;
     PUT(" tecla de funcion seguida de la cantidad.");
     NEW_LINE(2);
     PUT(" Puede imprimirse el total con la tecla de igual (=). El signo");
     NEW_LINE;
     PUT(" de la exclamacion (!) borra el total. Teclear @ para terminar.");
     NEW_LINE(2);
END EXPLAIN;

PROCEDURE CALC IS
BEGIN
     WHILE KEY /= '@' LOOP  
          CASE KEY IS
               WHEN '+' | '-' | '*' | '/' =>
                    GET(NUM);
                    NEW_LINE;
               WHEN OTHERS => NULL;
          END CASE;
          CASE KEY IS
               WHEN '+' => CALCULATE.ADD(NUM);
               WHEN '-' => CALCULATE.SUB(NUM);
               WHEN '*' => CALCULATE.MUL(NUM);
               WHEN '/' => IF NUM = 0.0 THEN
                              RAISE DIVIDE_BY_ZERO;
                           ELSE
                               CALCULATE.DIV(NUM);
                           END IF;
               WHEN '=' => CALCULATE.EQU(NUM);
                           PUT(NUM);
                           NEW_LINE;
               WHEN '!' => CALCULATE.CLEAR;
                           NEW_LINE;
               WHEN '?' => EXPLAIN;
               WHEN '@' => NULL;
               WHEN OTHERS =>
                           PUT(" Las alternativas son +,-,*,/,!,@.");
                           NEW_LINE;
                           PUT(" Teclear ? para pedir ayuda.");
                           NEW_LINE;
          END CASE;
          PUT(":");
          GET(KEY);
     END LOOP;
END CALC;

BEGIN

     PUT(" Calculadora de 4 Funciones del Ada");    
     CALC;
     
     EXCEPTION
     
        WHEN DIVIDE_BY_ZERO =>
             PUT(" Error de division por cero");
             PUT(" Ingresar nuevo divisor:");
             CALC;
             
END CALCULA;             