with TEXT_IO;use TEXT_IO;
with Sequential_IO;

Procedure Ministerio_Hacienda is

-------------------------------------------------------------------------------
--                    DECLARACION DE CONSTANTES                              --
-------------------------------------------------------------------------------
   
   Max_Cuentas_Clientes : constant Integer := 100;
   Max_Bancos : constant Integer := 10;
      
-------------------------------------------------------------------------------
--                    DECLARACION DE SUBTIPOS                                --
-------------------------------------------------------------------------------

   Subtype Natural is Integer range 0..Integer'Last;
   Subtype Tipo_Codigo_Cliente is Natural range 0..9999;
   subtype Tipo_Codigo_Banco is Natural range 0..9999;
   subtype Tipo_Nombre is String(1..20);
   subtype Rango_Cuentas_Clientes is Natural range 0..Max_Cuentas_Clientes;
   subtype Rango_Bancos is Natural range 0..Max_Bancos;
      
-------------------------------------------------------------------------------
--                     DECLARACION DE TIPOS                                  --
-------------------------------------------------------------------------------

   type Tipo_Cuenta_Cliente is record
           Nombre : Tipo_Nombre;
           Codigo_Cliente : Tipo_Codigo_Cliente;
           Saldo : Natural;
           Codigo_Banco : Tipo_Codigo_Banco;
   end record;
   
   type Tipo_Banco is record
           Nombre : Tipo_Nombre;
           Total : Natural;
           Codigo_Banco : Tipo_Codigo_Banco;
   end record;
       
   type Tipo_Tabla_Cuentas_Clientes is array (1..Max_Cuentas_Clientes) of
           Tipo_Cuenta_Cliente;
           
   type Tipo_Lista_Cuentas_Clientes is record
           Num_Cuentas_Clientes : Rango_Cuentas_Clientes;
           Clientes : Tipo_Tabla_Cuentas_Clientes;
   end record;
    
   type Tipo_Tabla_Bancos is array (1..Max_Bancos) of Tipo_Banco;
   
   type Tipo_Lista_Bancos is record
           Num_Bancos : Rango_Bancos;
           Bancos : Tipo_Tabla_Bancos;
   end record;
   
-------------------------------------------------------------------------------
--                 DECLARACION DE PAQUETES DE ENTRARA Y SALIDA               --
-------------------------------------------------------------------------------

   package ES_Integer is new Integer_IO(Integer); 
   use ES_Integer;
   package Cuentas_IO is new Sequential_IO(Tipo_Lista_Cuentas_Clientes);
   use Cuentas_IO;
   package Bancos_IO is new Sequential_IO(Tipo_Lista_Bancos);
   use Bancos_IO;
   
-------------------------------------------------------------------------------
--                     DECLARACION DE VARIABLES                              --
-------------------------------------------------------------------------------

   Lista_Cuentas_Clientes : Tipo_Lista_Cuentas_Clientes;
   Lista_Bancos : Tipo_Lista_Bancos;
   Opcion : natural range 1..6;
   Finalizar : Boolean := False;
   No_Hay_Cuentas,No_Hay_Bancos,No_Existe_Cuenta,No_Existe_Banco,Data_Error : Exception;

-------------------------------------------------------------------------------
--                  DECLARACION DE PROCEDIMIENTOS Y FUNCIONES                --
-------------------------------------------------------------------------------
        
   procedure Borrar_Pantalla is
      begin
          new_line(24);
      end Borrar_Pantalla;

   
   procedure Inicializacion_de_Variables (Cuentas_Actuales : in out 
         Tipo_Lista_Cuentas_Clientes; Bancos_Actuales : in out 
         Tipo_Lista_Bancos) is
     F1 : Cuentas_IO.file_type;
     F2 : Bancos_IO.file_type;
     begin
          open (F1,in_file,"Cuentas.dat");
          open (F2,in_file,"Bancos.dat");
          read (F1,Cuentas_Actuales);
          read (F2,Bancos_Actuales);
          close(F1);
          close(F2);
     end Inicializacion_de_Variables;   
        
           
        
   procedure Escribir_en_Ficheros (Cuentas_Actuales : in 
             Tipo_Lista_Cuentas_Clientes; Bancos_Actuales : in 
             Tipo_Lista_Bancos ) is
         F1 : Cuentas_IO.File_Type;
         F2 : Bancos_IO.file_type;
         Lista_Clientes : Tipo_Lista_Cuentas_Clientes;
         Lista_Bancos : Tipo_Lista_Bancos;
         begin
               open(F1,out_file,"Cuentas.dat");
               open(F2,out_file,"Bancos.dat");
               Lista_Clientes.Num_Cuentas_Clientes := 
                                  Cuentas_Actuales.Num_Cuentas_Clientes;
               for i in 1..Cuentas_Actuales.Num_Cuentas_Clientes loop
                  Lista_Clientes.Clientes(i) := Cuentas_Actuales.Clientes(i);
               end loop;
               write(F1,Lista_Clientes);
               Lista_Bancos.Num_Bancos := Bancos_Actuales.Num_Bancos;
               for x in 1..Bancos_Actuales.Num_Bancos loop
                  Lista_Bancos.Bancos(x) := Bancos_Actuales.Bancos(x);
               end loop;   
               write(F2,Lista_Bancos);
         end Escribir_En_Ficheros;
            
   function Localizar_Cuenta_Cliente(Codigo : in Tipo_Codigo_Cliente;
        Lista_Cuentas : in Tipo_Lista_Cuentas_Clientes) return Natural is
     begin
        if Lista_Cuentas.Num_Cuentas_Clientes = 0 then
           raise No_Hay_Cuentas;
        else
           for I in 1..Lista_Cuentas.Num_Cuentas_Clientes loop
              if Lista_Cuentas.Clientes(I).Codigo_Cliente = Codigo then
                   return I;
              end if;
           end loop;
        end if;  
        return 0;    
     end Localizar_Cuenta_Cliente;

   function Localizar_Banco(Codigo : in Tipo_Codigo_Banco; 
       Lista_Bancos : in Tipo_Lista_Bancos) return Natural is
     begin
        if Lista_Bancos.Num_Bancos = 0 then
              raise No_Hay_Bancos;
           else
              for I in 1..Lista_Bancos.Num_Bancos loop
                 if Lista_Bancos.Bancos(I).Codigo_Banco = Codigo then
                      return I;
                 end if;
              end loop;
              return 0;
           end if;
     end Localizar_Banco;  

   procedure MH_1 (Lista_Cuentas_Clientes : in out Tipo_Lista_Cuentas_Clientes;
        Lista_Bancos : in out Tipo_Lista_Bancos) is


   --  Declaracion de Variables Locales al procemiento MH_1
                                
        Salir : Boolean := False;
        Numero : Natural range 1..6;                      

   
   -- Declaracion de Procedimientos y Funciones del procedimiento MH_1
     
        procedure Insertar_Cuenta_Cliente (Cuentas_Actuales : in out
           Tipo_Lista_Cuentas_Clientes;Bancos_Actuales : in out 
           Tipo_Lista_Bancos) is
          
           type Textos is array (1..80) of character;
           Cliente_Aux : Tipo_Cuenta_Cliente; 
           Posicion : Natural;
           Nombre_Aux : Textos;
           x : Integer := 0;
           Num_C_C : Natural;
        
           begin
           
           -- Obtener datos de la nueva Cuenta
           
              Nombre_Aux := (1..80=>' ');
              put("Nombre Cliente:");
              loop
                 x := x + 1;
                 get(Nombre_Aux(x));
                 exit when End_of_Line or x = 80;
              end loop;
              for i in 1..20 loop
                 Cliente_Aux.Nombre(i) := Nombre_aux(i);
              end loop;
              new_line;
              put("Codigo Cliente:");
              get(Cliente_Aux.Codigo_Cliente);
              new_line;
              put("Saldo:");
              get(Cliente_Aux.Saldo);
              new_line;
              put("Codigo del Banco:");
              get(Cliente_Aux.Codigo_Banco);
           
           -- Asignar los datos al array y modificar total del Banco
        
              Cuentas_Actuales.Num_Cuentas_Clientes := 
                               Cuentas_Actuales.Num_Cuentas_Clientes + 1;
              Num_C_C := Cuentas_Actuales.Num_Cuentas_Clientes;
              Cuentas_Actuales.Clientes(Num_C_C) := Cliente_Aux;
              Posicion := 
                 Localizar_Banco(Cliente_Aux.Codigo_Banco,Bancos_Actuales);
              if Posicion = 0 then
                 raise No_Existe_Banco;
              end if;
              Bancos_Actuales.Bancos(Posicion).Total:=
                 Bancos_Actuales.Bancos(Posicion).Total + Cliente_Aux.Saldo;
           
           end Insertar_Cuenta_Cliente;
     
      procedure Insertar_Banco (Bancos: in out Tipo_Lista_Bancos) is
        
           type Textos is array (1..80) of character;
           Banco_Aux : Tipo_Banco;
           Nombre_Aux : Textos;
           x : integer:= 0;
        
           begin
        
           -- Obtener datos del nuevo Banco
        
              Nombre_Aux := (1..80=>' ');
              put("Nombre del Banco:");
              loop
                 x := x + 1;
                 get(Nombre_Aux(x));
                 exit when End_of_Line or x = 80;
              end loop;
              for i in 1..20 loop
                 Banco_Aux.Nombre(i) := Nombre_Aux(i);
              end loop;
              new_line;
              put ("Codigo del Banco:");
              get(Banco_Aux.Codigo_Banco);
              new_line;
              Banco_Aux.Total := 0;
           
           -- Asignar los datos al array de Bancos
                   
              Bancos.Num_Bancos := Bancos.Num_Bancos + 1;
              Bancos.Bancos(Bancos.Num_Bancos) := Banco_Aux;
           
           end Insertar_Banco;
        
     
      procedure Borrar_Cuenta_Cliente (Cuentas_Actuales : in out 
           Tipo_Lista_Cuentas_Clientes; Bancos_Actuales : in out 
           Tipo_Lista_Bancos) is
        
           Codigo_C : Tipo_Codigo_Cliente;
           Codigo_B : Tipo_Codigo_Banco;
           Posicion1 : Natural;
           Posicion2 : Natural;
       
           procedure Reordenar_Array_Cuentas (Num_Pos : in Natural;
              Cuentas: in out Tipo_Lista_Cuentas_Clientes) is
              begin
           
                 for x in Num_Pos..Cuentas.Num_Cuentas_Clientes loop
                     Cuentas.Clientes(x) := Cuentas.Clientes(x+1);
                 end loop;
                 Cuentas.Num_Cuentas_Clientes := 
                         Cuentas.Num_Cuentas_Clientes - 1;
           
              end Reordenar_Array_Cuentas;
        
           begin
        
           -- Obtener los datos de la cuenta a eliminar 
           -- y Banco a la que pertenece.
           
              put("Introduce codigo de Cliente:");
              get(Codigo_C);
              new_line;
              put("Introduce codigo del Banco :");
              get(Codigo_B);
              new_line;
              Posicion1 := Localizar_Banco(Codigo_B,Bancos_Actuales);
              Posicion2 := Localizar_Cuenta_Cliente(Codigo_C,Cuentas_Actuales);
              if Posicion1 = 0 then
                 raise No_Existe_Banco;
              elsif Posicion2 = 0 then
                 raise No_Existe_Cuenta;
              end if;
           -- Encontrar nuevo total del Banco y Reordenar el array
        
              Bancos_Actuales.Bancos(Posicion1).Total := 
                             Bancos_Actuales.Bancos(Posicion1).Total - 
                             Cuentas_Actuales.Clientes(Posicion2).Saldo;
              Reordenar_Array_Cuentas(Posicion2,Cuentas_Actuales);
           end Borrar_Cuenta_Cliente;
   
      procedure Bancarrota (Bancos_Actuales : in out Tipo_Lista_Bancos;
           Cuentas_Actuales : in out Tipo_Lista_Cuentas_Clientes) is
        
           Codigo_B : Tipo_Codigo_Banco;
           Posicion : Natural;
      
           procedure Reordenar_Array_Bancos(Num_Pos : in Integer;
                                            Bancos: in out Tipo_Lista_Bancos) is
              begin
                   for i in Num_Pos..Bancos.Num_Bancos loop
                     Bancos.Bancos(i) := Bancos.Bancos(i+1);
                   end loop;
                   Bancos.Num_Bancos := Bancos.Num_Bancos - 1;
              end Reordenar_Array_Bancos;
                  
           procedure Reordenar_Array_Cuentas(Codigo : in Tipo_Codigo_Banco;
              Cuentas : in out Tipo_Lista_Cuentas_Clientes) is
              x : integer := 0;
              begin
                   loop
                      x := x + 1;      
                      if Cuentas.Clientes(x).Codigo_Banco = Codigo then
                         Cuentas.Num_Cuentas_Clientes :=  
                                 Cuentas.Num_Cuentas_Clientes - 1;
                         for i in x..Cuentas.Num_Cuentas_Clientes loop
                            Cuentas.Clientes(i) := Cuentas.Clientes(i+1);
                         end loop;
                         x := x - 1;
                      end if;
                      exit when x = Cuentas.Num_Cuentas_Clientes;
                   end loop;
              end Reordenar_Array_Cuentas;
              
         
           begin
           -- Obtener codigo del banco a eliminar
              
              put("Introduce codigo del Banco: ");
              get(Codigo_B);
              new_line;
              Posicion := Localizar_Banco(Codigo_B,Bancos_Actuales);
              if Posicion = 0 then
                   raise No_Existe_Banco;
              end if;
              Reordenar_Array_Bancos(Posicion,Bancos_Actuales);
              Reordenar_Array_Cuentas(Codigo_B,Cuentas_Actuales);           
           end Bancarrota;
   
      procedure Comprobacion (Cuentas_Actuales : in Tipo_Lista_Cuentas_Clientes;
           Bancos_Actuales : in Tipo_Lista_Bancos) is
           c:character;
           begin
              new_line(2);
              put("Bancos:");
              new_line;
              for x in 1..Bancos_Actuales.Num_Bancos loop
                 put(Bancos_Actuales.Bancos(x).Codigo_Banco);
                 put("    ");
                 put(Bancos_Actuales.Bancos(x).nombre);
                 put("   ");
                 put(Bancos_Actuales.Bancos(x).Total);
                 new_line;
              end loop;
              new_line(2);
              put("Clientes:");
              new_line;
              for i in 1.. Cuentas_Actuales.Num_Cuentas_Clientes loop
                 put(Cuentas_Actuales.Clientes(i).codigo_Cliente);
                 put("    ");
                 put(Cuentas_Actuales.Clientes(i).nombre);
                 put("   ");
                 put(Cuentas_Actuales.Clientes(i).Codigo_banco);
                 new_line;
                 put("   ");
                 put(Cuentas_Actuales.Clientes(i).Saldo);new_line;
              end loop;
              put ("Pulse una tecla para continuar.....: ");
              get(c);
              new_line;
           end Comprobacion;
        
        -- Cuerpo Principal del Procedimiento MH_1         
   
      begin 
         Borrar_Pantalla;
         while not Salir loop
            new_line(15);
            put ("                      Ministerio de Hacienda");
            new_line;
            put ("                      ----------------------");
            new_line;
            new_line;
            put ("                   1. Insertar Cuenta de Cliente");
            new_line;
            put ("                   2. Insertar Banco");
            new_line;
            put ("                   3. Borrar Cuenta de Cliente");
            new_line;
            put ("                   4. Bancarrota");
            new_line;
            new_line;
            put ("                   5. Abandonar proceso");
            new_line;            
            new_line(8);
            put (" Elige opcion (1..5) :");
            get (Numero);
            case Numero is
               when 1 => Insertar_Cuenta_Cliente(Lista_Cuentas_Clientes,
                                                 Lista_Bancos);
               when 2 => Insertar_Banco(Lista_Bancos);
               when 3 => Borrar_Cuenta_Cliente(Lista_Cuentas_Clientes,
                                               Lista_Bancos);
               when 4 => Bancarrota(Lista_Bancos,Lista_Cuentas_Clientes);
               when 5 => Salir := True;
               when 6 => Comprobacion(Lista_Cuentas_Clientes,Lista_Bancos);
               when others => null;
            end case;
            Escribir_En_Ficheros(Lista_Cuentas_Clientes,Lista_Bancos);
         end loop;

   end MH_1;


-----------------------------------------------------------------------------


   procedure MH_2 (Lista_Cuentas_Clientes : in out Tipo_Lista_Cuentas_Clientes;
                   Lista_Bancos : in out Tipo_Lista_Bancos) is

   --  Declaracion de Variables Locales al procedimiento MH_2
   
   Numero : Natural range (1..4);
   Salir : Boolean := False;

   -- Procedimientos Locales a MH_2         
      procedure OBTENER_CUENTAS_CLIENTES(Cuentas_actuales : in 
                                      Tipo_Lista_Cuentas_Clientes;
                                      Bancos_Actuales : in Tipo_Lista_Bancos) is

         Banco : Tipo_Codigo_Banco;              

         begin
            New_line(8);
            Put("   Introduzca codigo de la entidad : ");
            Get(Banco);
            New_line(4);
            Put("  NOMBRE              CODIGO CLIENTE      SALDO        ");
            new_line;
            Put("-------------------------------------------------------");
            New_line(2);
            for Lista in 1..Cuentas_actuales.Num_Cuentas_Clientes loop
                  if Cuentas_actuales.Clientes(Lista).Codigo_Banco = Banco then
                      put(Cuentas_actuales.Clientes(Lista).Nombre);
                      Put("      ");
                      put(Cuentas_actuales.Clientes(Lista).Saldo);
                      Put("         ");
                      put(Cuentas_actuales.Clientes(lista).Codigo_Cliente);
                      new_line; 
                  end if;
            end loop;          
      end OBTENER_CUENTAS_CLIENTES;
      Procedure OBTENER_CUENTAS(Cuentas_Actuales : 
                                in Tipo_lista_Cuentas_Clientes;
         Bancos_actuales : in Tipo_Lista_Bancos) is
         Codigo : Natural range 0..9999;
         Aux : natural;
         Aux1 : Natural;
         begin
            New_line(8);
            Put(" Introduzca Codigo del Cliente : ");
            get(codigo);
            Aux := Localizar_Cuenta_Cliente(codigo,Cuentas_Actuales);
            new_line(2);
            put(Cuentas_Actuales.Clientes(Aux).Nombre);
            put("     ");
            put("Codigo_Cliente :");
            put(codigo);
            new_line(2);
            put("Cuentas en la actualidad.....");
            new_line;
            put("   Banco                   Saldo ");
            new_line;
            put("---------------------------------");
            new_line;
            For Listado in 1..Cuentas_actuales.Num_Cuentas_Clientes loop
               if Cuentas_actuales.Clientes(listado).Codigo_Cliente=Codigo then
                      Aux1 := Localizar_Banco(Cuentas_Actuales.
                              Clientes(listado).Codigo_Banco,Bancos_Actuales);
                      put(Bancos_Actuales.Bancos(Aux1).Nombre);
                      put("      ");
                      put(Cuentas_actuales.Clientes(listado).Saldo);
                      put("       ");
                      new_line;
               end if;
            end loop;          
     end OBTENER_CUENTAS;
     
     Procedure COMPROBAR (Cuentas_actuales : in Tipo_lista_Cuentas_clientes;
           Bancos_actuales : in Tipo_Lista_Bancos) is
           Codigo : Natural Range 0..9999;
           Suma : Natural := 0;
           Aux : Natural;
                         
         begin
            New_line(8);
            Put(" Introduzca el codigo del Banco que desea Comprobar");
            put(" Codigo : ");
            get(Codigo);
            for i in 1..Cuentas_actuales.Num_Cuentas_clientes loop
                  if Cuentas_actuales.Clientes(i).Codigo_banco = Codigo then
                       Suma := Suma+Cuentas_Actuales.Clientes(i).Saldo;
                  end if;
            end loop;
            Aux:=localizar_Banco(codigo,Bancos_Actuales);
            If abs(Suma-Bancos_Actuales.Bancos(aux).Total) 
                  < ((Bancos_actuales.Bancos(aux).Total * 5 ) / 100) then
                  put("   El banco ");
                  put(Bancos_Actuales.Bancos(aux).Nombre);
                  new_line;
                  put("tiene sus cuentas en orden.");
            else
                  put("   El banco ");
                  put(Bancos_Actuales.Bancos(aux).Nombre);
                  new_line;
                  put("tiene sus cuentas desordenadas.");
            end if;                    
      end Comprobar;
              
   begin
         Borrar_Pantalla;
         While not Salir loop
            put("                Ministerio De Hacienda");
            new_line;
            put("                ----------------------");
            new_line;
            Put("             1. Obtener Cuentas de un Banco");
            new_line;
            Put("             2. Obtener Cuentas de un Cliente");
            new_line;
            Put("             3. Comprobar el estado de un Banco");
            New_line;
            Put("             4. Salir.");
            New_line(8);
            Put(" Escoja Opcion (1..4)...: ");
            Get(Numero);
            Case Numero is
                When 1 => Obtener_Cuentas_Clientes(Lista_Cuentas_Clientes,
                                                   Lista_Bancos);
                When 2 => Obtener_Cuentas(Lista_Cuentas_Clientes,Lista_Bancos);
                When 3 => Comprobar(Lista_Cuentas_Clientes,Lista_Bancos);
                When 4 => Salir := True;
                When others=>null;
            end case;
         end loop;
   end MH_2;

   -- Cuerpo del Procedimiento Principal Ministerio_Hacienda

   begin
        
        Inicializacion_de_Variables(Lista_Cuentas_Clientes,Lista_Bancos);
        Borrar_Pantalla;
        while not Finalizar loop 
           put("                   Ministerio de Hacienda");
           put("                   ----------------------");
           new_line;
           put("                   1. Actualizar Datos");
           new_line;
           put("                   2. Listar Datos");
           new_line;
           put("                   3. Salir del Programa");
           new_line(8);
           put(" Escoja Opcion (1..3)...: ");
           get(Opcion);
           case Opcion is
                when 1 => MH_1(Lista_Cuentas_Clientes,Lista_Bancos);
                when 2 => MH_2(Lista_Cuentas_Clientes,Lista_Bancos);
                when 3 => Finalizar := True;
                when others =>null;
           end case;
           Escribir_En_Ficheros(Lista_Cuentas_Clientes,Lista_Bancos);
        end loop;
        
        exception
        
            when Constraint_Error =>
                 new_line;
                 put("ERROR :  Asignacion fuera del Rango");
                 new_line;
                 
            when Data_Error =>     
                 new_line;
                 put("ERROR : Sobrepasado el saldo maximo. Maximo = 32767");
                 new_line;
                 
            when No_Hay_Cuentas => 
                 new_line;
                 Put("ERROR : No hay cuentas en la actualidad");
                 new_line;
                 
            when No_Hay_Bancos => 
                 new_line;
                 put("ERROR : No hay Bancos en la actualidad");
                 new_line;
                 
            when No_Existe_Banco =>
                 new_line; 
                 put ("ERROR : No existe el banco indicado");
                 new_line;
                 
            when No_Existe_Cuenta => 
                 new_line;
                 put ("ERROR : No exite esa cuenta");
                 new_line;
                 
    end Ministerio_Hacienda;
