

with lineas,
     listas_apunt_lineas,
     listas_apunt_tokens;

package Contextos is

     type Contexto is private;

     MaxNivel : constant Positive := 5;

     procedure Crear_Contexto
          (Ctx: out Contexto;
           LAL: in Listas_Apunt_Lineas.Tipo_Lista_Apunt_Lineas;
           NumLin: in Positive;
           Nivel: in Positive);
     -- Entrada: Contexto < Ctx
     --          Lista_Apunt_Lineas < LAL
     --          Positivo < NumLin (num. de linea del que obtener contexto
     --          Positivo < Nivel (nivel de lineas de contexto deseado)
     -- Salida:  Contexto > Ctx
     -- Efecto:  Construye el contexto (que sera una lista de apuntadores
     --        de lineas) a partir de una lista de apuntadores de lineas que
     --        debe contener el programa original, el numero de linea del que
     --        se desea obtener el contexto y el nivel (lineas) de contexto
     --        deseado

     procedure Escribir_Contexto
          (Ctx : Contexto;
           ActTok : Listas_Apunt_Tokens.Tipo_Lista_Apunt_Tokens);
     -- Entrada : Contexto < Ctx
     --           Lista_Apunt_Tokens < ActTok
     -- Salida: Ninguna
     -- Efecto: Escribe a pantalla el contexto que se le pasa como parametro,
     --         el parametro 'ActTok' se utiliza para hacer un resaltado en
     --         pantalla del token del que se pide la traduccion



private

     type Contexto is new Listas_Apunt_Lineas.Tipo_Lista_Apunt_Lineas;

end Contextos;
