with Strings_Variables;

package equivalencias is

     type Equivalencia is limited private;

     function Crear_Equivalencia(S1,S2 : in Strings_Variables.String_Variable)
                return Equivalencia;
     -- Entrada: String_Variable <- S1,S2
     -- Salida : Devuelve una equivalencia
     -- Efecto : Copia el parametro S1 en el campo equivalencia.original
     --         y el parametro S2 en el campo equivalencia.traducido

     procedure Copiar (E1: out Equivalencia; E2: in Equivalencia);
     -- Entrada: Equivalencia <- E1, E2
     -- Salida : Equivalencia -> E1
     -- Efecto : Asigna el contenido de E2 en E1

     function Original(E : Equivalencia)
       return Strings_Variables.String_Variable;
     -- Entrada: Equivalencia <- E
     -- Salida : Devuelve un String_Variable
     -- Efecto : Devuelve el campo 'original' de la equivalencia que se
     --          le pasa como parametro en un string_variable

     function Traduccion(E : Equivalencia)
       return Strings_Variables.String_Variable;
     -- Entrada: Equivalencia <- E
     -- Salida : Devuelve un string_variable
     -- Efecto : Devuelve el campo 'traduccion' de la equivalencia que se
     --          pasa como parametro en un string_variable

     function "=" (E1,E2: Equivalencia) return Boolean;
     -- Entrada: Equivalencia <- E1,E2
     -- Salida : Devuelve un boolean
     -- Efecto : Compara los campos 'original' de los dos parametros y
     --          devuelve el resultado booleano correspondiente, se usa
     --          para la insercion en una lista ordenada

private

      type Equivalencia is record
          Original   : Strings_Variables.String_Variable;
          Traduccion : Strings_Variables.String_Variable;
      end Record;

end equivalencias;
