-- Paquete de gestion de menus

with Text_IO;

package Gestion_Menus is

    subtype TOpcion is Character range '0' .. '9';
               -- tipo de las opciones posibles en un menu

    subtype TMenu is Text_IO.File_Type;
               -- tipo menu: fichero de texto, que contiene
               -- una linea por opcion

    procedure Inicializar
        (Nombre_FOpciones : in String; FOpciones : in out TMenu);
        -- Entrada: nombre externo del fichero que contiene las
        --           opciones de un menu (Nombre_FOpciones)
        -- Salida: fichero de opciones FOpciones, abierto
        -- Efecto: abre el fichero Nombre_FOpciones

    procedure Visualizar (FOpciones : in out TMenu);
        -- Entrada: fichero de opciones FOpciones, abierto
        -- Salida: fichero de opciones FOpciones, cerrado
        -- Efecto: visualiza por pantalla el menu contenido en
        --         FOpciones, y cierra FOpciones

    function Opcion return TOpcion;
        -- Entrada:
        -- Salida: opcion de menu elegida por el usuario
        -- Efecto: requiere al usuario para que elija una de las
        --         opciones de un menu que ha sido previamente
        --         visualizado en la pantalla; la operacion no termina
        --         hasta que el usuario elija una opcion correcta

end Gestion_Menus;


