with lista_equivalencias,
     programa_traducido,
     strings_variables,
     listas_apunt_lineas,
     listas_apunt_tokens,
     equivalencias,
     contextos,
     lineas,
     tokens,
     text_io;

package body interactivo is


procedure Inicializar (NombreFichero : String) is
  begin
    Text_io.Put_Line ("Inicializando estructuras...");
    Lista_Identificadores_Estandar.Inicializar;
    Lista_Equivalencias.Inicializar;
    Programa_Original.Inicializar (NombreFichero);
    Programa_Traducido.Inicializar;
  end Inicializar;



procedure Traducir (Todo : in Boolean) is

    NumLin : Positive := 1;
    PTok   : Listas_Apunt_Tokens.Tipo_Lista_Apunt_Tokens;
    Lin    : Lineas.Linea;


       function LeerLinea return Strings_Variables.String_Variable is
            StrLin : String(1..60) := (others => ' ');
            StrVar : Strings_Variables.String_Variable;
            Lon    : Natural;
         begin
           Strings_Variables.Copiar(strVar, Strings_Variables.FString_Vacio);
           Text_io.Get_Line (StrLin, Lon);
           Strings_Variables.Copiar (StrVar, Strings_Variables.FString_Var(

                StrLin(1..Lon)));
           return StrVar;
         end LeerLinea;



     procedure LimpiaPantalla is
       begin
         Text_io.Put (ASCII.ESC & "[2J");
         Text_io.Set_Line (1); Text_io.Set_Col(1);
       end LimpiaPantalla;


     procedure PedirTraduccion (S: Strings_Variables.String_Variable) is
       begin
         text_io.new_Line;
         text_io.put_line (" - Introduzca la traduccion");
         text_io.put_line (ASCII.ESC & "[1m");
         text_io.put (Strings_Variables.Valor (S));
         text_io.put (" => " & ASCII.ESC & "[0m");
       end PedirTraduccion;


     procedure HacerTraduccion (Annadir: Boolean;
                                 Tok: Tokens.Token;
                                 Num: Positive) is

          Trad : Strings_Variables.String_Variable;
          Equiv: Equivalencias.Equivalencia;
       begin
         Strings_Variables.Copiar (Trad, LeerLinea);
         if not Strings_Variables.Es_Vacio (Trad) then
           Programa_Traducido.Traducir (Num, Tok, Trad);
         else
           Strings_Variables.Copiar (Trad, Tokens.Cadena(Tok));
         end if;
         if Annadir then
           Equivalencias.Copiar (Equiv,
           Equivalencias.Crear_Equivalencia(Tokens.Cadena(Tok),Trad));
           Lista_Equivalencias.Annadir (Equiv);
         end if;
       end HacerTraduccion;



     procedure TratarToken (PTok: Listas_Apunt_Tokens.Tipo_Lista_Apunt_Tokens;
                            NumLin : Positive) is
          Tok : Tokens.Token;
      begin
        Tokens.Copiar (Tok, Listas_Apunt_Tokens.Primer_Token (PTok).all);
        case Tokens.Clase(Tok) is
          when Tokens.Identificador =>
            if not Lista_Identificadores_Estandar.Esta(Tokens.Cadena(Tok)) then
               if not Lista_Equivalencias.Esta (Tokens.Cadena(Tok)) then
                   LimpiaPantalla;
                   Contextos.Escribir_Contexto (
                      Programa_Original.Dame_Contexto(NumLin, 3), PTok);
                   PedirTraduccion (Tokens.Cadena (Tok));
                   HacerTraduccion (True, Tok, NumLin);
               else
                   Programa_Traducido.Traducir (NumLin, Tok,
                       Lista_Equivalencias.Traduccion(Tokens.Cadena(Tok)));
               end if;
            end if;
          when Tokens.Comentario | Tokens.Cadena =>
            if (Todo) then
               LimpiaPantalla;
               Contextos.Escribir_Contexto (
                      Programa_Original.Dame_Contexto (NumLin, 4), PTok);
               PedirTraduccion (Tokens.Cadena (Tok));
               Text_io.New_Line;
               HacerTraduccion (False, Tok, NumLin);
            end if;
          when Others =>
               null;
        end case;
      end TratarToken;


  begin -- Traducir

    while NumLin <= Programa_Original.Dame_NumLin loop
      Lineas.Copiar(Lin, Programa_Original.Dame_Linea_n(NumLin).all);
      Listas_Apunt_Tokens.Copiar_Puntero (PTok , Lineas.Analisis (Lin));

      while not Listas_Apunt_Tokens.Es_Lista_Vacia (PTok) loop
        TratarToken (PTok, NumLin);
        Listas_Apunt_Tokens.Copiar_Puntero (PTok,
             Listas_Apunt_Tokens.Resto_Lista (PTok));
      end loop;
      NumLin := NumLin + 1;
    end loop;
  end Traducir;



procedure Terminar(NombreFichero : String) is
  begin
    Programa_Traducido.Escribir_Traducido (NombreFichero);
  end Terminar;


end interactivo;
