with programa_original,
     lista_identificadores_estandar;

package Interactivo is

     procedure Inicializar (NombreFichero : String);
     -- Entrada: String <- NombreFichero
     -- Salida : ninguna
     -- Efecto : Llama a todos los procedimientos de inicializacion necesarios
     --          para comenzar el proceso de traduccion cargando el fichero
     --          de nombre 'NombreFichero'

     procedure Traducir (Todo : in Boolean);
     -- Entrada: Booleano <- Todo
     -- Salida : ninguna
     -- Efecto : Si la variable Todo es true procede a una traduccion completa
     --          incluyendo comentarios y cadenas de caracteres, en caso
     --          contrario solo se traducen los identificadores

     procedure Terminar(NombreFichero : String);
     -- Entrada: String <- NombreFichero
     -- Salida : ninguna
     -- Efecto : Se graba el fichero traducido con nombre 'NombreFichero'

Identificadores_No_Encontrado : exception
        renames Lista_Identificadores_Estandar.Fichero_No_Encontrado;
-- no se ha encontrado el fichero de identificadores estandar

Original_No_Encontrado : exception
        renames Programa_Original.Fichero_No_Encontrado;
-- no se ha encontrado el fichero que se especifica como entrada

Palabras_Reservadas_No_Encontrado : exception
        renames Programa_Original.Palabras_Reservadas_No_Encontrado;
-- no se ha encontrado el fichero de palabars reservadas

Error_Lexico : exception renames Programa_Original.Error_Lexico;
-- se ha producido un error durante el analisis lexico


end Interactivo;
