with Lineas, Listas;

package Listas_Apunt_Lineas is

     type Apunt_Linea is access Lineas.Linea;

     type Tipo_Lista_Apunt_Lineas is private;

     procedure Crear_Lista_Vacia (LAL : out Tipo_Lista_Apunt_Lineas);
     -- Entrada:
     -- Salida : Tipo_lista_Apunt_Lineas -> LAL
     -- Efecto : Crea una lista de apuntadores de lineas vacia

     procedure Annadir_Linea (LAL : in out Tipo_Lista_Apunt_Lineas;
                              Lin: in Lineas.Linea);
     -- Entrada: Tipo_Lista_Apunt_Lineas <- LAL
     --          Linea <- Lin
     -- Salida : Tipo_Lista_Apunt_Lineas -> LAL
     -- Efceto : Modifica la lista LAL aadiendole una nueva linea 'lin'

     procedure Copiar_Puntero (L1: out Tipo_Lista_Apunt_Lineas;
                               L2: in Tipo_Lista_Apunt_Lineas);
     -- Entrada: Tipo_Lista_Apunt_Lineas <- L2
     -- Salida : Tipo_Lista_Apunt_Lineas -> L1
     -- Efecto : L1 apunta a la misma lista que L2

     function Resto_Lista (LAL : Tipo_Lista_Apunt_Lineas)
          return Tipo_Lista_Apunt_Lineas;
     -- Entrada: Tipo_Lista_Apunt_Lineas <- LAL
     -- Salida : devuelve un objeto de tipo Tipo_lista_Apunt_Lineas
     -- Efecto : devuelve una nueva lista igual a LAL quitandole el
     --          primer elemento de LAL

     function Dame_Linea (LAL : Tipo_Lista_Apunt_Lineas)
          return Apunt_Linea;
     -- Entrada: Tipo_Lista_Apunt_Lineas <- LAL
     -- Salida : devuelve un objeto de tipo Apunt_Linea
     -- Efecto : devuelve el apuntador a la linea del primer nodo de la
     --          lista LAL

     function Dame_Linea_n (LAL: Tipo_Lista_Apunt_Lineas; N: Positive)
          return Apunt_Linea;
     -- Entrada: Tipo_Lista_Apunt_Lineas <- LAL
     --          Positivo <- N
     -- Salida : devuelve un objeto de tipo Apunt_Lineas
     -- Efecto : devuelve el apuntador a la linea del nodo N-esimo de
     --          la lista LAL

     function Es_Lista_Vacia (LAL: Tipo_Lista_Apunt_Lineas) return Boolean;
     -- Entrada: Tipo_Lista_Apunt_Lineas <- LAL
     -- Salida : devuelve un objeto boolean indicando si LAL es vacia o no
     -- Efecto :

     procedure Copiar_Lista (LAL1: out Tipo_Lista_Apunt_Lineas;
                             LAL2: in Tipo_Lista_Apunt_Lineas);
     -- Entrada: Tipo_Lista_Apunt_Lineas <- LAL2
     -- Salida : Tipo_Lista_Apunt_Lineas -> LAL1
     -- Efecto : LAL1 apunta a la misma lista que LAL2

private

     package Lista_Lineas is new Listas (Elemento => Apunt_Linea);

     type Tipo_Lista_Apunt_Lineas is new Lista_Lineas.Lista;

end Listas_Apunt_Lineas;

