with Listas, Tokens, Strings_Variables;

package listas_apunt_tokens is

     type Apunt_Token is access Tokens.Token;

     type Tipo_Lista_Apunt_Tokens is private;

     procedure Crear_Lista_Vacia (LAT: in out Tipo_Lista_Apunt_Tokens);
     -- Entrada: Tipo_Lista_Apunt_Tokens <- LAT
     -- Salida : Tipo_Lista_Apunt_Tokens -> LAT
     -- Efecto : Crea un lista vacia de apuntadores de tokens

     procedure Annadir_Token (LAT: in out Tipo_Lista_Apunt_Tokens;
                              T : Apunt_Token);
     -- Entrada: Tipo_Lista_Apunt_Tokens <- LAT
     --          Apunt_Token <- T
     -- Salida : Tipo_Lista_Apunt_Tokens -> LAT
     -- Efecto : El token T ha sido aadido a la lista LAT

     procedure Copiar_Puntero (LAT1: out Tipo_Lista_Apunt_Tokens;
                               LAT2: in Tipo_Lista_Apunt_Tokens);
     -- Entrada: Tipo_Lista_Apunt_Tokens <- LAT
     -- Salida : Tipo_Lista_Apunt_Tokens -> LAT
     -- Efecto : LAT1 apunta al mismo nodo que LAT2

     procedure Copiar_Lista (LAT1: out Tipo_Lista_Apunt_Tokens;
                             LAT2: in Tipo_Lista_Apunt_Tokens);
     -- Entrada: Tipo_Lista_Apunt_Tokens <- LAT1
     -- Salida : Tipo_Lista_Apunt_Tokens -> LAT2
     -- Efecto : Se construye una nueva lista sobre LAT1 que es copia de la
     --          lista LAT2

     function Primer_Token (LAT: Tipo_Lista_Apunt_Tokens) return Apunt_Token;
     -- Entrada: Tipo_Lista_Apunt_Tokens <- LAT
     -- Salida : devuelve un objeto de tipo apunt_token
     -- Efecto : devuelve el apuntador token del primer nodo de la lista

     function Resto_Lista (LAT: Tipo_Lista_Apunt_Tokens)
          return Tipo_Lista_Apunt_Tokens;
     -- Entrada: Tipo_Lista_Apunt_Tokens <- LAT
     -- Salida : devuelve un objeto de tipo Tipo_Lista_Apunt_Tokens
     -- Efecto : se devueleve una nueva lista igual que LAT excepto su primer
     --          elemento

     function Es_Lista_Vacia (LAT: Tipo_Lista_Apunt_Tokens) return Boolean;
     -- Entrada: Tipo_Lista_Apunt_Tokens <- LAT
     -- Salida : objeto de tipo boolean que indica si la LAT es vacia o no
     -- Efecto :


     procedure Hacer_String (LAT: in Tipo_Lista_Apunt_Tokens;
                             Str: in out Strings_Variables.String_Variable);
     -- Entrada: Tipo_Lista_Apunt_Tokens <- LAT
     --          String_Variable <- Str
     -- Salida : String_Variable -> Str
     -- Efecto : construye un string_variable concatenando todos los tokens
     --          que forman la lista LAT

  private

     package Lista_Apunt_Tokens is new Listas (Elemento => Apunt_Token);

     type Tipo_Lista_Apunt_Tokens is new Lista_Apunt_Tokens.Lista;

end listas_apunt_tokens;

