with Strings_Variables,
     Listas_Ordenadas;

package Lista_Identificadores_Estandar is

     procedure Inicializar;
     -- Entrada:
     -- Salida :
     -- Efecto : carga el fichero de 'fidents_estandar.txt' y construye
     --          la lista de identificadores estandar ADA

     function Esta (H: in Strings_Variables.String_Variable) return Boolean;
     -- Entrada: String_Variable <- H
     -- Salida : devuelve un objeto de tipo boolean
     -- Efecto : Si el string_variable 'H' se encuentra en la lista de iden-
     --          tificadores devuelve true, false en c.c.

     Fichero_No_Encontrado : exception;

private

   subtype StrClave is String(1..40);

   function DameClave (E: Strings_Variables.String_Variable) return StrClave;
   -- Funcion que dado un string variable devuelve la clave para su
   -- ordenacin en la lista

   package Identificadores_Estandar is new Listas_Ordenadas (
               Elemento => Strings_Variables.String_Variable,
               TClave   => StrClave,
               Orden    => "<",
               Clave    => DameClave,
               Copiar   => Strings_Variables.Copiar);


end Lista_Identificadores_Estandar;
