with Analexico;

package body lineas is



  function Crear (NumLinea: Positive;
                  Str: Strings_Variables.String_Variable) return Linea is
      Lin : Linea;
    begin
      Lin.NumLinea := NumLinea;
      Analexico.Obtener_Lista_Apunt_Tokens (Str, Lin.Analisis);
      return Lin;
    exception
        when Analexico.Token_Desconocido =>
                raise Error_Lexico;
    end Crear;


  function Numero_Linea (Lin: Linea) return Positive is
    begin
      return Lin.NumLinea;
    end Numero_Linea;


  function Cadena (Lin: Linea) return Strings_Variables.String_Variable is
      Str : Strings_Variables.String_Variable;
    begin
      Strings_Variables.Copiar (Str, Strings_Variables.FString_Vacio);
      Listas_Apunt_Tokens.Hacer_String (Lin.Analisis, Str);
      return Str;
    end Cadena;


  function Analisis (Lin: Linea)
       return Listas_Apunt_Tokens.Tipo_Lista_Apunt_Tokens is
    begin
      return Lin.Analisis;
    end Analisis;


  procedure Copiar (L1: out Linea; L2: in Linea) is
    begin
      L1.NumLinea := L2.NumLinea;
      Listas_Apunt_Tokens.Copiar_Puntero (L1.Analisis, L2.Analisis);
    end Copiar;


  procedure Copiar_Lista (L1: out Linea; L2: in Linea) is
    begin
      L1.NumLinea := L2.NumLinea;
      Listas_Apunt_Tokens.Copiar_Lista (L1.Analisis, L2.Analisis);
    end Copiar_Lista;


   procedure Traducir (Lin  : in out Linea;
                       Tok  : in Tokens.Token;
                       Trad : in Strings_Variables.String_Variable) is

        PAux : Listas_Apunt_Tokens.Tipo_Lista_Apunt_Tokens := Lin.Analisis;
     begin
       while not Listas_Apunt_Tokens.Es_Lista_Vacia (PAux) loop
         if Tokens."=" (Tok, Listas_Apunt_Tokens.Primer_Token(PAux).all) then
           Tokens.Traducir (Listas_Apunt_Tokens.Primer_Token(PAux).all, Trad);
         end if;
         Listas_Apunt_Tokens.Copiar_Puntero (PAux,
              Listas_Apunt_Tokens.Resto_Lista (PAux));
       end loop;
     end Traducir;


end lineas;
