with Strings_Variables, Listas_Ordenadas;

package lista_palabras_reservadas is

     procedure Inicializar;
     -- Entrada:
     -- Salida :
     -- Efecto : Carga el fichero de palabras reservadas ADA y construye
     --          la lista de palabras reservadas, si no encuentra el fichero
     --          de palabras reservadas se eleva 'Fichero_No_Encontrado'

     function Esta (H: in Strings_Variables.String_Variable) return Boolean;
     -- Entrada: String_Variable <- H
     -- Salida : devuelve un objeto de tipo booleano
     -- Efecto : si existe en la lista de palabras reservadas una palabra
     --          reservada con clave H devuelve true, false en c.c.

     Fichero_No_Encontrado : exception;

private

   subtype StrClave is String(1..40);

   function DameClave (E: Strings_Variables.String_Variable) return StrClave;
   -- dado un string variable devuelve la clave de ordenacin de este para
   -- su insercin la lista ordenada

   package Palabras_Reservadas is new Listas_Ordenadas (
               Elemento => Strings_Variables.String_Variable,
               TClave   => StrClave,
               Orden    => "<",
               Clave    => DameClave,
               Copiar   => Strings_Variables.Copiar);

end lista_palabras_reservadas;
