with Text_io;

package body lista_equivalencias is


     Lista : Equivalencias_Ordenadas.ListOrd;


procedure Inicializar is
  begin
    Equivalencias_Ordenadas.Crear_Vacia (Lista);
  end Inicializar;



procedure Cargar_Fichero (Nombre: in String) is

     Orig,Trad       : Strings_Variables.String_Variable;
     FEquiv          : Text_io.File_Type;
     UnaEquivalencia : Equivalencias.Equivalencia;

       function LeerLinea return Strings_Variables.String_Variable is
            StrLin : StrClave := (others => ' ');
            StrVar : Strings_Variables.String_Variable;
            Lon    : Natural;
         begin
           Strings_Variables.Copiar(strVar, Strings_Variables.FString_Vacio);
           Text_io.Get_Line (StrLin, Lon);
           if Lon = 0 then
                raise Fichero_Incorrecto;
           end if;
           Strings_Variables.Copiar (StrVar, Strings_Variables.FString_Var (
              StrLin(1..Lon)));
           return StrVar;
         end LeerLinea;


  begin
    Inicializar;
    Text_io.Open (FEquiv, Text_io.In_File, Nombre);
    Text_io.Set_Input (FEquiv);
    while not Text_io.End_of_file loop
       Strings_Variables.Copiar(Orig, LeerLinea);
       Strings_Variables.Copiar(Trad, LeerLinea);
       Equivalencias.Copiar (UnaEquivalencia,
            Equivalencias.Crear_Equivalencia (Orig, Trad));
       Annadir (UnaEquivalencia);
    end loop;
    Text_io.Close (FEquiv);
    Text_io.Set_Input (Text_io.Standard_Input);
  exception
    when Text_io.End_Error =>
         raise Fichero_Incorrecto;
    when Text_io.Name_Error =>
         raise Fichero_No_Encontrado;
  end Cargar_Fichero;


procedure Guardar_Fichero (Nombre: in String) is
     LAux : Equivalencias_Ordenadas.ListOrd;
     Equiv : Equivalencias.Equivalencia;
     FEqui : Text_io.File_Type;
  begin
    Text_io.Create (FEqui, Text_io.Out_File, Nombre);
    Equivalencias_Ordenadas.Copiar (LAux, Lista);
    while not Equivalencias_Ordenadas.Es_Vacia (LAux) loop
       Equivalencias.Copiar (Equiv, Equivalencias_Ordenadas.Primero (LAux));
       Text_io.Put_Line (FEqui,
            Strings_Variables.Valor (Equivalencias.Original(Equiv)));
       Text_io.Put_Line (FEqui,
            Strings_Variables.Valor(Equivalencias.Traduccion(Equiv)));
       Equivalencias_Ordenadas.Copiar (LAux,
            Equivalencias_Ordenadas.Resto (LAux));
    end loop;
    Text_io.Close (FEqui);
  end Guardar_Fichero;



procedure Annadir(E : in Equivalencias.Equivalencia) is
  begin
    Equivalencias_Ordenadas.Insertar (Lista, E);
  end Annadir;


procedure Eliminar(E : in Equivalencias.Equivalencia) is
  begin
    Equivalencias_Ordenadas.Eliminar (Lista, E);
  end Eliminar;


function Esta(E : Strings_Variables.String_Variable) return Boolean is
     Eq : Equivalencias.Equivalencia;
  begin
    Equivalencias.Copiar (Eq, Equivalencias.Crear_Equivalencia (
         Strings_Variables.En_Minusculas(E),
         Strings_Variables.FString_Vacio));
    return Equivalencias_Ordenadas.Esta (Lista, Eq);
  end Esta;


function Traduccion (Orig: Strings_Variables.String_Variable)
     return Strings_Variables.String_Variable is
     Eq : Equivalencias.Equivalencia;
      K : StrClave := (others => ' ');
  begin
    K(1..Strings_Variables.Longitud(Orig)) := Strings_Variables.Valor (
         Strings_Variables.En_Minusculas(Orig));
    Equivalencias.Copiar (Eq, Equivalencias_Ordenadas.Buscar (Lista, K));
    return Equivalencias.Traduccion (Eq);
  end Traduccion;


function DameClave (E: Equivalencias.Equivalencia) return StrClave is
    SClave : StrClave := (others => ' ');
  begin
    SClave (1..Strings_Variables.Longitud (Equivalencias.Original(E))) :=
         Strings_Variables.Valor (Equivalencias.Original(E));
    return SClave;
  end DameClave;


end lista_equivalencias;
