package body Listas is

        procedure Crear_Vacia (L : out Lista) is
        begin
                L := null;
        end Crear_Vacia;


        procedure Annadir (L : in out Lista; E : Elemento) is
            Nuevo_Nodo : Lista;
            Aux : Lista := L;
        begin
                Nuevo_Nodo := new Nodo'(E,null);
                if Es_Vacia (L) then
                        L:= Nuevo_Nodo;
                else
                        while Aux.Sig /= null loop
                                Aux := Aux.Sig;
                        end loop;
                        Aux.Sig := Nuevo_Nodo;
                end if;
        end Annadir;


        procedure Insertar (L : in out Lista; E : Elemento; N : Positive) is
                Posicion : Positive := N;
                Nuevo_Nodo : Lista;
                Aux : Lista;
        begin
                if N = 1 then
                        Nuevo_Nodo := new Nodo'(E, L);
                        L := Nuevo_Nodo;
                elsif Es_Vacia (L) then
                           raise Posicion_Excesiva;
                else
                        -- {Posicion > 1 y not Es_Vacia (L)}
                        Aux := L;
                        while Aux.Sig /= null and Posicion > 2 loop
                                Aux := Aux.Sig;
                                Posicion := Posicion - 1;
                        end loop;
                        if Posicion /= 2 then
                                raise Posicion_Excesiva;
                        else
                                Nuevo_Nodo := new Nodo;
                                Nuevo_Nodo.Info := E;
                                Nuevo_Nodo.Sig := Aux.Sig;
                                Aux.Sig := Nuevo_Nodo;
                        end if;
                end if;
        end Insertar;


        function Valor (L : in Lista; N : in Positive) return Elemento is
                Posicion : Positive := N;
                Aux : Lista := L;
        begin
                if Es_Vacia (L) then
                        raise Posicion_Excesiva;
                else
                        while Aux.Sig /= null and Posicion > 1 loop
                                Aux := Aux.Sig;
                                Posicion := Posicion - 1;
                        end loop;
                        if Posicion /= 1 then
                                raise Posicion_Excesiva;
                        else
                                return Aux.Info;
                        end if;
                end if;
        end Valor;


        function Esta (L : Lista; E : Elemento) return Boolean is
                Aux : Lista := L;
                Encontrado : Boolean := False;
        begin
                while Aux /= null and not Encontrado loop
                        if Aux.Info = E then
                                Encontrado := True;
                        end if;
                        Aux := Aux.Sig;
                end loop;
                return Encontrado;
        end Esta;


        procedure Eliminar (L : in out Lista; E : Elemento) is
                Aux : Lista;
                Es_Primero : Boolean := True;
        begin
                if not Es_Vacia (L) then
                        while L /= null and Es_Primero loop
                                if  L.Info = E then
                                        L := L.Sig;
                                else
                                        Es_Primero := False;
                                end if;
                        end loop;
                        if L /= null then
                                Aux := L;
                                while Aux.Sig /= null loop
                                  if Aux.Sig.Info = E then
                                     Aux.Sig := Aux.Sig.Sig;
                                  else
                                     Aux := Aux.Sig;
                                  end if;
                                end loop;
                        end if;
                end if;
        end Eliminar;


        function Longitud (L : Lista) return Natural is
                Aux : Lista := L;
                Conta: Natural := 0;
        begin
                while Aux /= null loop
                        Aux := Aux.Sig;
                        Conta := Conta + 1;
                end loop;
                return Conta;
        end Longitud;


        function Primero (L : Lista) return Elemento is
        begin
                if Es_Vacia (L) then
                        raise Lista_Vacia;
                else
                        return L.Info;
                end if;
        end Primero;


        function Ultimo  (L : Lista) return Elemento is
                Aux : Lista := L;
        begin
                if Es_Vacia (L) then
                        raise Lista_Vacia;
                else
                        while Aux.Sig /= null loop
                                Aux := Aux.Sig;
                        end loop;
                        return Aux.Info;
                end if;
        end Ultimo;


        function Resto (L : Lista) return Lista is
        -- no se hace copia; se devuelve apuntador
        --al segundo elemento de la lista original
        begin
                if Es_Vacia (L) then
                        raise Lista_Vacia;
                else
                        return L.Sig;
                end if;
        end Resto;


        function Principal (L : Lista) return Lista is
         -- lista original menos el ultimo elemento; se hace copia
                Aux : Lista := L;
                Resultado : Lista := null;
                Ult_Result : Lista := Resultado;
        begin
                if Es_Vacia (L) then
                   raise Lista_Vacia;
                else
                   if Aux.Sig =  null then
                           return Resultado;
                   else
                      while Aux.Sig /= null loop
                         if Ult_Result = null then
                            Resultado := new Nodo'(Aux.Info, null);
                            Ult_Result := Resultado;
                         else
                            Ult_Result.Sig :=
                                  new Nodo'(Aux.Info, null);
                            Ult_Result := Ult_Result.Sig;
                         end if;
                         Aux := Aux.Sig;
                      end loop;
                      return Resultado;
                   end if;
                end if;
        end Principal;


        function Posicion (L :  Lista; E : Elemento) return Positive is
        -- posicion de la ultima aparicion de E
                Aux : Lista := L;
                Conta : Positive := 1;
                Pos : Natural  := 0;
        begin
                while Aux /= null  loop
                        if Aux.Info = E then
                                Pos := Conta;
                        end if;
                        Conta := Conta + 1;
                        Aux := Aux.Sig;
                end loop;
                if Pos > 0 then
                        return Pos;
                else
                        raise Elemento_Inexistente;
                end if;
        end Posicion;


        function Es_Vacia (L : Lista) return Boolean is
        begin
                return L = null;
        end Es_Vacia;


        procedure Copiar (L2 : out Lista; L1 : in Lista) is
        begin
            L2 := L1;
        end Copiar;


        procedure Copiar_Lista (L2 : out Lista; L1 : in Lista) is
             Aux : Lista := L1;
        begin
            while Aux /= null loop
               Annadir (L2, Primero(Aux));
               Aux := Resto(Aux);
             end loop;
        end Copiar_Lista;


end Listas;
