with Text_io;

package body listas_ordenadas is

     procedure Crear_Vacia (L: out ListOrd) is
       begin
         L := null;
       end Crear_Vacia;


     procedure Insertar (L: in out ListOrd; E: Elemento) is
          Actual : ListOrd :=L;
          Anterior : ListOrd := null;
          Nuevo : ListOrd;
       begin
         if L = null then                            -- insertar al
              L := new Nodo;                          -- prinicipio de
              Copiar (L.Info, E);                     -- la lista
              L.Siguiente := null;
         else
           while Actual /= null loop                -- buscamos posicion
              if Orden(Clave(Actual.Info), Clave(E)) then -- para efectuar la
                   Anterior := Actual;                    -- insercin
                   Actual := Actual.Siguiente;
              else
                   Exit;                               -- posicion encontrada
              end if;
           end loop;
           if Anterior = null then
                Nuevo := new Nodo;
                Nuevo.Siguiente := L;
                Copiar (Nuevo.Info, E);
                L := Nuevo;
           elsif Actual /= null then
                if Clave(Actual.Info) /= Clave(E) then   -- no se permiten
                     Nuevo := new Nodo;                  -- claves repetidas
                     Copiar (Nuevo.Info, E);
                     Nuevo.Siguiente := Actual;
                     Anterior.Siguiente := Nuevo;
                end if;
           else                                           -- insertar al
                Nuevo := new Nodo;                        -- final de la
                Copiar (Nuevo.Info, E);                   -- lista
                Nuevo.Siguiente := null;
                Anterior.Siguiente := Nuevo;
           end if;
         end if;
      end Insertar;


     function Buscar (L: in ListOrd; K: in TClave) return Elemento is
          Actual : ListOrd := L;
       begin
         while Actual /= null loop
              if Orden (Clave(Actual.Info), K) then
                   Actual:= Actual.Siguiente;
              else
                  if Clave(Actual.Info) = K then     -- si no esta en esta
                       return Actual.Info;           -- posicion, el elemento
                  else                               -- no esta en la lista
                       raise Inexistente;
                  end if;
              end if;
         end loop;
         raise Inexistente;                          -- el elemento no esta
       end Buscar;


     function Esta(L: ListOrd; E: Elemento) return Boolean is
          Actual : ListOrd := L;
       begin
         while not Es_Vacia(Actual) loop
              if Orden (Clave(Actual.Info), Clave(E)) then
                   Actual := Actual.Siguiente;
              else
                  if Clave(Actual.Info) = Clave(E) then
                       return true;
                  else
                       return false;
                  end if;
              end if;
         end loop;
         return false;                          -- el elemento no esta
       end Esta;


     function Primero (L: ListOrd) return Elemento is
       begin
         if Es_Vacia (L) then
              raise Lista_Vacia;
         else
              return L.Info;
         end if;
       end Primero;


     function Resto (L: ListOrd) return ListOrd is
       begin
         if Es_Vacia (L) then
              raise Lista_Vacia;
         else
              return L.Siguiente;
         end if;
       end Resto;


     procedure Eliminar (L: in out ListOrd; E: Elemento) is
          Actual : ListOrd := L;
          Anterior : ListOrd := null;
        begin
          if not Es_Vacia(L) then
               while Actual /= null loop
                 if Orden (Clave(Primero(Actual)), Clave(E)) then
                      Anterior := Actual;
                      Actual := Resto(Actual);
                 elsif Clave(Primero(Actual)) = Clave(E) then
                      if Anterior = null then
                           L := Resto(L);       -- borrar al comienzo
                      else
                           Anterior.Siguiente := Actual.Siguiente;
                      end if;
                 end if;
               end loop;
          end if;
        end Eliminar;


     function Es_Vacia (L: ListOrd) return Boolean is
       begin
         return L = null;
       end Es_Vacia;


     procedure Copiar (L1: out ListOrd; L2: in ListOrd) is
       begin
         L1 := L2;
       end Copiar;


end listas_ordenadas;
