with programa_traducido,
     strings_variables,
     listas_apunt_lineas,
     listas_apunt_tokens,
     equivalencias,
     lineas,
     tokens,
     text_io;


package body no_interactivo is


 procedure Crear_Listado_Identificadores (
       Nombre_Fichero_Entrada,
       Nombre_Fichero_Identificadores : String) is

           NumLin : Positive := 1;
           PTok   : Listas_Apunt_Tokens.Tipo_Lista_Apunt_Tokens;
           Tok    : Tokens.Token;
           Lin    : Lineas.Linea;

   begin
    Text_io.Put_Line ("Inicializando estructuras...");
    Lista_Identificadores_Estandar.Inicializar;
    Lista_Equivalencias.Inicializar;
    Programa_Original.Inicializar (Nombre_Fichero_Entrada);
    Text_io.Put_Line ("Creando fichero de identificadores...");
    while NumLin <= Programa_Original.Dame_NumLin loop
      Lineas.Copiar(Lin, Programa_Original.Dame_Linea_n(NumLin).all);
      Listas_Apunt_Tokens.Copiar_Puntero (PTok , Lineas.Analisis (Lin));

      while not Listas_Apunt_Tokens.Es_Lista_Vacia (PTok) loop
        Tokens.Copiar (Tok, Listas_Apunt_Tokens.Primer_Token (PTok).all);
        if Tokens."=" (Tokens.Clase(Tok), Tokens.Identificador) then
          if not Lista_Identificadores_Estandar.Esta(Tokens.Cadena(Tok)) and
             not Lista_Equivalencias.Esta(Tokens.Cadena(Tok)) then

              Lista_Equivalencias.Annadir (Equivalencias.Crear_Equivalencia (
                   Tokens.Cadena(Tok),
                   Strings_Variables.FString_Vacio));
          end if;
        end if;
        Listas_Apunt_Tokens.Copiar_Puntero (PTok,
           Listas_Apunt_Tokens.Resto_Lista (PTok));
      end loop;
      NumLin := NumLin + 1;
    end loop;
    Lista_Equivalencias.Guardar_Fichero (Nombre_Fichero_Identificadores);
   end Crear_Listado_Identificadores;



 procedure Traducir (Nombre_Fichero_Original,
                     Nombre_Fichero_Equivalencias : String) is

      NumLin : Positive := 1;
      PTok   : Listas_Apunt_Tokens.Tipo_Lista_Apunt_Tokens;
      Lin    : Lineas.Linea;
      Tok    : Tokens.Token;


      function LeerLinea return Strings_Variables.String_Variable is
            StrLin : String(1..60) := (others => ' ');
            StrVar : Strings_Variables.String_Variable;
            Lon    : Natural;
         begin
           Strings_Variables.Copiar(strVar, Strings_Variables.FString_Vacio);
           Text_io.Get_Line (StrLin, Lon);
           Strings_Variables.Copiar (StrVar, Strings_Variables.FString_Var(
                StrLin(1..Lon)));
           return StrVar;
         end LeerLinea;


   begin
     Text_io.Put_Line ("Inicializando estructuras...");
     Lista_Identificadores_Estandar.Inicializar;
     Programa_Original.Inicializar (Nombre_Fichero_Original);
     Programa_Traducido.Inicializar;
     Lista_Equivalencias.Cargar_Fichero (Nombre_Fichero_Equivalencias);
     Text_io.Put_Line ("Realizando la traduccion...");
     while NumLin <= Programa_Original.Dame_NumLin loop
      Lineas.Copiar(Lin, Programa_Original.Dame_Linea_n(NumLin).all);
      Listas_Apunt_Tokens.Copiar_Puntero (PTok , Lineas.Analisis (Lin));
      while not Listas_Apunt_Tokens.Es_Lista_Vacia (PTok) loop
        Tokens.Copiar (Tok, Listas_Apunt_Tokens.Primer_Token (PTok).all);
        if Tokens."=" (Tokens.Clase(Tok), Tokens.Identificador) then
          if not Lista_Identificadores_Estandar.Esta(Tokens.Cadena(Tok)) then
            if Lista_Equivalencias.Esta (Tokens.Cadena(Tok)) then
              Programa_Traducido.Traducir (NumLin, Tok,
                       Lista_Equivalencias.Traduccion(Tokens.Cadena(Tok)));
            else
              text_io.Put_Line ("No se ha encontrado traduccion para '" &
                Strings_Variables.Valor (Tokens.Cadena (Tok)) & "'.");
              text_io.Put_Line ("Introduzca la traduccion:");
              text_io.put (Strings_Variables.Valor (Tokens.Cadena (Tok)) &
                " = ");
              Programa_Traducido.Traducir (NumLin, Tok, LeerLinea);
            end if;
          end if;
        end if;
        Listas_Apunt_Tokens.Copiar_Puntero (PTok,
           Listas_Apunt_Tokens.Resto_Lista (PTok));
      end loop;
      NumLin := NumLin + 1;
    end loop;
   end Traducir;


 procedure Terminar (Nombre_Fichero_Salida : String) is
   begin
     Text_io.Put_Line ("Creando fichero traducido...");
     Programa_Traducido.Escribir_Traducido (Nombre_Fichero_Salida);
   end Terminar;


end no_interactivo;
