with programa_original,
     lista_identificadores_estandar,
     lista_equivalencias;

package no_interactivo is

 procedure Crear_Listado_Identificadores (
       Nombre_Fichero_Entrada,
       Nombre_Fichero_Identificadores : String);
 -- Entrada: String <- Nombre_Fichero_Entrada
 --          String <- Nombre_Fichero_Identificadores
 -- Salida :
 -- Efecto : Dado un programa ADA de nombre 'Nombre_Fichero_Entrada'
 --          crea un fichero de texto de nombre 'Nombre_Fichero_Identi-
 --          ficadores' con todos los identificadores a traducir

 procedure Traducir (Nombre_Fichero_Original,
                     Nombre_Fichero_Equivalencias : String);
 -- Entrada: String <- Nombre_Fichero_Original
 --          String <- Nombre_Fichero_Equivalencias
 -- Salida :
 -- Efecto : Dado un programa ADA y un fichero de texto con las
 --          traducciones para cada uno de los identificadores que
 --          aparezcan en el se procede a sustituir cada identificador
 --          por su correspondiente traduccion, si no se encuentra la
 --          traduccion de algun identificador se solicita sta por
 --          parte del usuario

 procedure Terminar (Nombre_Fichero_Salida : String);
 -- Entrada: String <- Nombre_Fichero_Original
 -- Salida :
 -- Efecto : Crea un fichero de texto de nombre 'Nombre_Fichero_Salida'
 --          con el programa ADA ya traducido


Identificadores_No_Encontrado : exception
        renames Lista_Identificadores_Estandar.Fichero_No_Encontrado;

Equivalencias_No_Encontrado : exception
        renames Lista_Equivalencias.Fichero_No_Encontrado;

Equivalencias_Incorrecto : exception
        renames Lista_Equivalencias.Fichero_Incorrecto;

Original_No_Encontrado : exception
        renames Programa_Original.Fichero_No_Encontrado;

Palabras_Reservadas_No_Encontrado : exception
        renames Programa_Original.Palabras_Reservadas_No_Encontrado;

Error_Lexico : exception
        renames Programa_Original.Error_Lexico;


end no_interactivo;
