with listas_apunt_lineas,
     strings_variables,
     lista_palabras_reservadas,
     tokens,
     lineas,
     contextos;

package Programa_Original is

     procedure Inicializar (NombreFichero: in String);
     -- Entrada: String <- NombreFichero
     -- Salida :
     -- Efecto : Llama a los procedimientos de inicializacin de los
     --          paquetes necesarios cargando el fichero de entrada y
     --          construyendo la lista de apuntadores de lineas
     --          'programa_original' que ser construida a partir del
     --          fichero especificado, si no se encuentra el fichero se
     --          eleva la excepcion 'Fichero_No_Encontrado'

     function Dame_Linea_n (N : Positive)
          return Listas_Apunt_Lineas.Apunt_Linea;
     -- Entrada: Positivo <- N
     -- Salida : devuelve un objeto de tipo Apunt_Linea
     -- Efecto : devuelve un apuntador a la N-esima linea del programa
     --          original contenido en la lista 'programa_original'

     function Dame_NumLin return Natural;
     -- Entrada:
     -- Salida : devuelve un entero positivo igual al num. de lineas
     --          que tenga el programa original
     -- Efecto :

     function Dame_Lista return Listas_Apunt_Lineas.Tipo_Lista_Apunt_Lineas;
     -- Entrada:
     -- Salida : devuelve un objeto de tipo Tipo_Lista_Apunt_Lineas
     -- Efecto : devuelve la lista 'programa_original'


     function Dame_Contexto (N : Positive; Nivel : Positive)
          return Contextos.Contexto;
     -- Entrada: Positivo <- N
     --          Positivo <- Nivel
     -- Salida : devuelve un objeto de tipo Contexto
     -- Efecto : devuelve el contexto para la linea N-esima del programa
     --          original con un nivel de contexto 'Nivel'


 Fichero_No_Encontrado : exception;
 Palabras_Reservadas_No_Encontrado : exception renames
        Lista_Palabras_Reservadas.Fichero_No_Encontrado;
 Error_Lexico : exception renames Lineas.Error_Lexico;

end Programa_Original;
