with Ada.Characters.Handling, Text_io;

package body Strings_Variables is

   procedure Copiar (T1 : out String_Variable; T2 : in String_Variable) is

   begin
      T1 := T2;
   end Copiar;

   function FString_Var (S : in String) return String_Variable is
      T : String_Variable;
   begin
      if S = "" then
         T.Long := 0;
      else
         T.Long := S'Last - S'First + 1;
         T.Valor (1 .. T.Long) := S;
      end if;
      return T;
   end FString_Var;

   function FString_Vacio return String_Variable is

   begin
      return (Long => 0, Valor => (others => ' '));
   end FString_Vacio;

   function Longitud (T : in String_Variable) return Indice is

   begin
      return T.Long;
   end Longitud;

   function Valor (T : in String_Variable) return String is

   begin
      if T.Long = 0 then
         return "";
      else
         return T.Valor (1 .. T.Long);
      end if;
   end Valor;

   function Es_Vacio (T : in String_Variable) return Boolean is

   begin
      return T.Long = 0;
   end Es_Vacio;

   function "=" (T1, T2 : in String_Variable) return Boolean is

   begin
      return Valor (T1) = Valor (T2);
   end "=";

   function "<=" (T1, T2 : in String_Variable) return Boolean is

   begin
      return Valor (T1) <= Valor (T2);
   end "<=";

   function ">=" (T1, T2 : in String_Variable) return Boolean is

   begin
      return Valor (T1) >= Valor (T2);
   end ">=";

   function "<" (T1, T2 : in String_Variable) return Boolean is

   begin
      return Valor (T1) < Valor (T2);
   end "<";

   function ">" (T1, T2 : in String_Variable) return Boolean is

   begin
      return Valor (T1) > Valor (T2);
   end ">";


   function "&" (T : in String_Variable; S : in String) return String_Variable is
      T_Aux : String_Variable;
   begin
      T_Aux.Long := T.Long + S'Length;
      T_Aux.Valor (1 .. T_Aux.Long) := Valor (T) & S;
      return T_Aux;
   end "&";


   function "&" (T1, T2 : in String_Variable) return String_Variable is
      T_Aux : String_Variable;
   begin
      T_Aux.Long := T1.Long + T2.Long;
      T_Aux.Valor (1 .. T_Aux.Long) := Valor (T1) & Valor (T2);
      return T_Aux;
   end "&";


   function "&" (S : in String; T : in String_Variable) return String_Variable is
      T_Aux : String_Variable;
   begin
      T_Aux.Long := S'Length + T.Long;
      T_Aux.Valor (1 .. T_Aux.Long) := S & Valor (T);
      return T_Aux;
   end "&";


   function En_Minusculas (T : in String_Variable) return String_Variable is

   begin
      return (T.Long,
              Ada.Characters.Handling.To_Lower (T.Valor));
   end En_Minusculas;


end Strings_Variables;

