
with Strings_Variables;

package tokens is

     type Clase_Token is (Identificador, Secuencia_Blancos, Fin_Linea,
                          Cadena, Concatenador, Comentario,
                          Palabra_Reservada, Otro);


     type Token is limited private;

     function FToken (S: in Strings_Variables.String_Variable;
                      M: in Clase_Token) return Token;
     -- Entrada: String_Variable <- S
     --          Clase_Token <- M
     -- Salida : devuelve un objeto de tipo token
     -- Efecto : construye un token a partir del string_variable S y el
     --          tipo de token M

     procedure Copiar(T1: out Token; T2: in Token);
     -- Entrada: Token <- T2
     -- Salida : Token -> T1
     -- Efecto : T1 toma el mismo valor para los campos 'Cadena' y 'Clase'
     --          que los que tiene T2

     procedure Traducir(T: out Token;
                        S: in Strings_Variables.String_Variable);
     -- Entrada: String_Variable <- S
     -- Salida : Token -> T
     -- Efecto : Se sustituye el campo 'Cadena' del token T por el
     --          string_variable S

     function Clase(T: Token) return Clase_Token;
     -- Entrada: Token <- T
     -- Salida : devuelve un objeto de tipo Clase_Token
     -- Efecto : devuelve el valor del campo 'Clase' del token T

     function Cadena(T: Token) return Strings_Variables.String_Variable;
     -- Entrada: Token <- T
     -- Salida : devuelve un objeto de tipo string_variable
     -- Efecto : se devuelve el valor del campo 'Cadena' del token T

     function "=" (T1, T2: Token) return Boolean;
     -- Entrada: Token <- T1
     --          Token <- T2
     -- Salida : devuelve un objeto de tipo booleano
     -- Efecto : compara los campos 'Cadena' y 'Clase' del token T si son
     --          iguales devuelve true y false en caso contrario


  private

     type Token is
          record
            Cadena: Strings_Variables.String_Variable;
            Clase: Clase_Token;
          end record;


end tokens;

